import com.threed.jpct.*;
import com.threed.jpct.util.*;
import com.threed.jpct.procs.*;
import java.util.*;

public class ObjectAttributes {
	
	public boolean load_matched = false;

	public String devkit_type = ObjectsLoader.DEVKIT_OBJECT_TYPE_NORMAL;
	public String key = "";
	public String file = "";	

	public float init_x = 0f;
	public float init_y = 0f;
	public float init_z = 0f;

	public float init_x_rot = 0f;
	public float init_y_rot = 0f;
	public float init_z_rot = 0f;

	public float x = 0f;
	public float y = 0f;
	public float z = 0f;

	public float x_rot = 0f;
	public float y_rot = 0f;
	public float z_rot = 0f;

	public boolean culling = false;
	public int transparency = -1;

	public boolean selected = false;

	public Object3D obj3D = null;

	public float init_scale = 1f;
	public float scale = 1f;

	/// light support
	public Light light = null;
	public float intensity_r = 150f;
	public float intensity_g = 150f;
	public float intensity_b = 150f;
	public float attenuation = 100f;

	private Vector _v = null;

	public void cloneValues(ObjectAttributes oa) throws Exception{
		try{
			devkit_type = oa.devkit_type;
			file = oa.file;
			init_x = oa.init_x;
			init_y = oa.init_y;
			init_z = oa.init_z;
			init_x_rot = oa.init_x_rot;
			init_y_rot = oa.init_y_rot;
			init_z_rot = oa.init_z_rot;
			x = oa.x;
			y = oa.y;
			z = oa.z;
			x_rot = oa.x_rot;
			y_rot = oa.y_rot;
			z_rot = oa.z_rot;
			culling = oa.culling;
			transparency = oa.transparency;
			init_scale = oa.init_scale;
			scale = oa.scale;
			if(scale <= 0)
				scale = 1;
			intensity_r = oa.intensity_r;
			intensity_g = oa.intensity_g;
			intensity_b = oa.intensity_b;
			attenuation = oa.attenuation;

			_v.clear();
			_v = null;
			_v = new Vector();
			for(int i = 0; i < oa.getExtensions().size(); i++){
				NVPair nv = (NVPair)oa.getExtensions().elementAt(i);
				_v.addElement(new NVPair(nv.name, nv.value));
			}

		}catch(Exception e){
			System.err.println("ObjectAttributes::cloneValues() " + e.getMessage());
			e.printStackTrace();
			throw e;
		}
	}

	public Vector getExtensions(){
		try{
			if(_v == null)
				_v = new Vector();			
		}catch(Exception e){
			System.err.println("ObjectAttributes::getExtensions() " + e.getMessage());
			e.printStackTrace();
		}
		return _v;
	}

	public void setExtensionStringValue(String skey, String svalue){
		try{
			boolean bfound = false;

			if(_v == null)
				_v = new Vector();

			for(int i=0; i < _v.size(); i++){
				NVPair nv = (NVPair)_v.elementAt(i);
				if(nv.name.equals(skey)){
					bfound = true;
					nv.value = svalue;
					break;
				}
			}

			if(!bfound)
				throw new Exception("Failed to find NVPair for [" + skey + "]");			

		}catch(Exception e){
			System.err.println("ObjectAttributes::setExtensionStringValue() " + e.getMessage());
			e.printStackTrace();
		}
	}

	public String getExtensionStringValue(String skey){
		String sret = "";
		try{

			boolean bfound = false;

			if(_v == null)
				_v = new Vector();

			for(int i=0; i < _v.size(); i++){
				NVPair nv = (NVPair)_v.elementAt(i);
				if(nv.name.equals(skey)){
					bfound = true;
					sret = nv.value;
					break;
				}
			}

			if(!bfound)
				throw new Exception("Failed to find NVPair for [" + skey + "]");			


		}catch(Exception e){
			System.err.println("ObjectAttributes::getExtensionStringValue() " + e.getMessage());
			e.printStackTrace();
		}
		return sret;
	}
}

